<?php
/* $Id: import.inc.php 3567 2009-11-03 13:01:08Z vadim $ */

//     
function AddClassForm () {
  global $UI_CONFIG;

  ?>
  <form enctype="multipart/form-data" action="import.php" method="post">
  <input type="hidden" name="MAX_FILE_SIZE" value="1000000"/>
  <fieldset>
  	<legend><font color="gray"><b><?=CONTROL_CLASS_IMPORT?></b></font></legend>
  	<input size="40" name="FilePatch" type="file"/>
  </fieldset><br/>
  <input type="hidden" name="phase" value="2"/>
  <input type="submit" class="hidden"/>
  </form>
  <?php

  $UI_CONFIG->actionButtons[] = array(
    "id" => "submit",
    "caption" => CONTROL_CLASS_IMPORT_UPLOAD,
    "action" => "mainView.submitIframeForm()"
  );
}


/**
 *     
 *
 * @param str file
 *
 * @return int component id
 */
function ParseClassFile ($file) {
	// system superior object
  $nc_core = nc_Core::get_object();
  
  $db = &$nc_core->db;
  
  $VersionNumber = $nc_core->get_settings("VersionNumber");

	$insert_flag = "%INSERT_ID%";
	$f = fopen($file, "r");

  // STEP 1: System version check
	$tpl_version = trim( fgets($f, 256) );

  if ($VersionNumber!=$tpl_version) {
	  nc_print_status( sprintf(CONTROL_CLASS_IMPORT_ERROR_VERSION_ID, $tpl_version, $VersionNumber), 'info');
	  return false;
	}
  
  // STEP 2: skip export info
  fgets($f, 256);
  
  // STEP 3: import component data
	$insert_into_class = trim( fgets($f, 65536) );

	$res1 = $db->query($insert_into_class);

 	if ($res1) {
		$insert_id = $db->insert_id;
 	}
 	else {
 		nc_print_status(CONTROL_CLASS_IMPORT_ERROR_CLASS_IMPORT, 'info');
		return false;
 	}

  // STEP 4: import component templates
  $next_data = trim( fgets($f, 65536) );
  while ( preg_match("/^INSERT INTO/is", $next_data) ) {
    // replace ID
    $next_data = str_replace($insert_flag, $insert_id, $next_data);
    
    if ( !$db->query($next_data) ) {
      nc_print_status(CONTROL_CLASS_IMPORT_ERROR_CLASS_TEMPLATE_IMPORT, 'info');
      $db->query("DELETE FROM `Class` WHERE `Class_ID` = '".$insert_id."'");
      return false;
    }
  
    $next_data = trim( fgets($f, 65536) );
  }
  
  // STEP 5: create MessageXX table
  $create_message = $next_data;
 	$create_message = str_replace($insert_flag, $insert_id, $create_message);

 	$res2 = $db->query($create_message);

 	if ($res2!=0) {
 		nc_print_status(CONTROL_CLASS_IMPORT_ERROR_MESSAGE_TABLE, 'info');
    $db->query("DELETE FROM `Class` WHERE `Class_ID` = '".$insert_id."' OR `ClassTemplate` = '".$insert_id."'");
		return false;
 	}

  // STEP 6: append component fields
	while( !feof($f) ) {
		$insert_into_field = trim( fgets($f, 4096) );
		$insert_into_field = str_replace($insert_flag, $insert_id, $insert_into_field);

		if ($insert_into_field) {
			$res3 = $db->query($insert_into_field);

			if ($db->captured_errors) {
				nc_print_status(CONTROL_CLASS_IMPORT_ERROR_FIELD, 'info');
				$db->query("DELETE FROM `Class` WHERE `Class_ID` = '".$insert_id."' OR `ClassTemplate` = '".$insert_id."'");
				$db->query("DROP TABLE `Message".$insert_id."`");
				$db->query("DELETE FROM `Field` WHERE `Class_ID` = '".$insert_id."'");
				return false;
			}
		}
 	}

  return $insert_id;
}


class ui_config_class_import extends ui_config {

  function ui_config_class_import($active_tab) {

    $this->headerText = CONTROL_CLASS_IMPORT;

    $this->headerImage = 'i_folder_big.gif';
    $this->tabs = array(
      array(
        'id' => 'import',
        'caption' => CONTROL_CLASS_IMPORT,
        'location' => "dataclass.import()"
      )
    );

    $this->activeTab = $active_tab;

    $this->locationHash = "#dataclass.".$active_tab."()";
    $this->treeSelectedNode = "dataclass.list";

    $this->treeMode = 'developer';
  }

}

?>